Skip to main content Skip to footer

Using Different Cell Editors per Row in the Same FlexGrid Column in JavaScript

Using Different Cell Editors per Row in the Same FlexGrid Column

Background:

FlexGrid does not natively support having multiple different editors for individual cells within the same column. However, you can achieve this behavior by dynamically swapping out the column’s editor in response to user interaction. This allows you to display a textbox, dropdown, color picker, or even a checkbox in the same column, depending on the data in other columns of the row.

Steps to Complete:

  1. Configure your grid's columns and editors.
  2. Use formatItem to customize the cell's UI based on row data.
  3. Use beginningEdit to dynamically assign the correct editor for the cell.
  4. Use cellEditEnded to update the underlying data after edits.

Getting Started:

Configure your grid's columns and editors

First, create the different editors your column might need, such as ComboBoxes, InputColor, or a simple text editor. Then, configure your FlexGrid with the target column (in this example, "value") set to one of these editors by default.

let countryEditor = new wjInput.ComboBox(document.createElement('div'), {
  itemsSource: getCountries(),
  displayMemberPath: 'name',
  selectedValuePath: 'name',
});
let cityEditor = new wjInput.ComboBox(document.createElement('div'), {
  itemsSource: getCities2(),
  displayMemberPath: 'codeName',
  selectedValuePath: 'codeName',
});
let textEditor = new wjInput.ComboBox(document.createElement('div'));
let colorEditor = new wjInput.InputColor(document.createElement('div'));

let grid = new Grid.FlexGrid('#grid', {
  autoGenerateColumns: false,
  columns: [
    { binding: 'id', header: 'Id', align: 'center' },
    { binding: 'category', header: 'Category', editor: categoryEditor, width: 120, isRequired: true },
    { binding: 'value', header: 'Value', width: 180, editor: colorEditor },
  ],
  itemsSource: view,
});

 

use formatItem to customize cell content

The formatItem event lets you change a cell’s appearance before it’s displayed.

grid.formatItem.addHandler((s, e) => {
  if (e.panel == s.cells) {
    let col = e.getColumn();
    if (col.binding == 'value') {
      let item = e.getRow().dataItem;
      if (item && item.category == 'Text') {
        let btn = e.cell.querySelector('.wj-btn');
        if (btn) btn.remove();
      } else if (item.category == 'Checkbox') {
        let chkbx = document.createElement('input');
        chkbx.type = 'checkbox';
        chkbx.checked = item.checkbox;
        chkbx.addEventListener('change', () => {
          item.checkbox = chkbx.checked;
          s.collectionView.refresh();
        });
        e.cell.innerHTML = '<span style="width: 100%; text-align: center; display: inline-block"></span>';
        e.cell.firstChild.appendChild(chkbx);
      }
    }
  }
});

 

Use beginningEdit to assign the correct editor

Before editing starts, decide which editor should be used based on the row’s category.
For checkboxes, cancel the edit so the inline control remains clickable without switching to an input.

grid.beginningEdit.addHandler((s, e) => {
  let column = e.getColumn();
  if (column.binding == 'value') {
    let item = e.getRow().dataItem;
    if (item) {
      switch (item.category) {
        case 'Country':
          column.editor = countryEditor;
          break;
        case 'City':
          column.editor = cityEditor;
          break;
        case 'Color':
          column.editor = colorEditor;
          break;
        case 'Text':
          column.editor = textEditor;
          break;
        case 'Checkbox':
          e.cancel = true;
          return;
      }
    }
  }
});

 

Use cellEditEnded to update the data

After editing is complete, copy the value from the active editor back into the appropriate field in your data model.

grid.cellEditEnded.addHandler((s, e) => {
  let column = e.getColumn();
  if (column.binding == 'value') {
    let item = e.getRow().dataItem;
    if (item) {
      let value = item.category == 'Color'
        ? column.editor.value
        : column.editor.selectedValue;
      switch (item.category) {
        case 'Country':
          item.country = value;
          break;
        case 'City':
          item.city = value;
          break;
        case 'Color':
          item.color = value;
          break;
        case 'Text':
          item.text = value;
          break;
      }
    }
  }
});

 

With this setup, the "value" column will display and edit its content differently depending on the selected category in the same row. Users can switch between text, dropdowns, color pickers, and checkboxes seamlessly, even after changing other cell values in the row.

You can see an sample application showcasing this here.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Using Different Cell Editors Per Row in the Same FlexGrid Column in React

Multiple editors per row in the same FlexGrid

Background:

Sometimes you want a single column in a FlexGrid to use different editors depending on which row is being edited. For example, one row might require a text editor, another might need a combo box, and yet another might use a checkbox.

You can accomplish this in FlexGrid by handling the prepareCellForEdit event and dynamically swapping the default cell editor for whatever editor suits the current row.

Steps to Complete:

  1. Handle the prepareCellForEdit event to check the row being edited.
  2. Based on the row’s data, replace the default editor with a custom editor (e.g., ComboBox, CheckBox).
  3. Ensure the selected editor value is written back to the cell on completion.

Getting Started:

Create a FlexGrid with Data

We define sample data that includes one column (type) that determines which editor should be used for the value column. We wire up the prepareCellForEdit event in React.

import React, { useRef } from 'react';
import { FlexGrid } from '@mescius/wijmo.react.grid';
import * as wjcInput from '@mescius/wijmo.input';

export default function App() {

  const gridRef = useRef(null);

  const data = [
    { type: 'text', value: 'Alpha' },
    { type: 'boolean', value: true },
    { type: 'options', value: 'Option1' },
    { type: 'text', value: 'Omega' }
  ];

  ...
  };

  return (
    <FlexGrid
      ref={gridRef}
      itemsSource={data}
      autoGenerateColumns={false}
      prepareCellForEdit={handlePrepareCellForEdit}
    >
      <FlexGrid.Column header="Type" binding="type" width={120} />
      <FlexGrid.Column header="Value" binding="value" width="*" />
    </FlexGrid>
  );
}

 

Handle the prepareCellForEdit event to check the row being edited

This intercepts the moment a cell enters edit mode so you can inspect which row and column is being edited.

grid.prepareCellForEdit.addHandler((s, e) => {
  const col = s.columns[e.col];
  const rowData = s.rows[e.row].dataItem;

  if (col.binding === 'value') {
    console.log('Editing row type:', rowData.type);
  }
});
  • e.row / e.col → tells you which cell is editing.
  • dataItem → gives you the actual row object.

 

Based on the row’s data, replace the default editor with a custom editor (e.g., ComboBox, CheckBox)

This creates and assigns a different editor depending on row data.

grid.prepareCellForEdit.addHandler((s, e) => {
  const col = s.columns[e.col];
  const rowData = s.rows[e.row].dataItem;

  if (col.binding === 'value') {

    // Clean up existing editor
    if (s.activeEditor?.dispose) {
      s.activeEditor.dispose();
    }

    if (rowData.type === 'boolean') {
      const chk = new wjcInput.CheckBox(s.hostElement);
      chk.checked = rowData.value;
      s.activeEditor = chk;

    } else if (rowData.type === 'options') {
      const cbo = new wjcInput.ComboBox(s.hostElement, {
        itemsSource: ['Option1', 'Option2', 'Option3'],
        text: rowData.value
      });
      s.activeEditor = cbo;
    }
  }
});
  • You inspect rowData.type.
  • You instantiate the appropriate control.
  • You assign it to s.activeEditor.

 

Ensure the selected editor value is written back to the cell on completion

This ensures that when the user changes the editor value, the underlying data item updates correctly.

// Example for CheckBox
chk.checkedChanged.addHandler(() => {
  rowData.value = chk.checked;
});

// Example for ComboBox
cbo.textChanged.addHandler(() => {
  rowData.value = cbo.text;
});
  • Editors must update rowData.
  • If you don’t sync data, the grid will visually update but the model won’t.

 

Combined File

export default function App() {

  const gridRef = useRef(null);

  const data = [
    { type: 'text', value: 'Alpha' },
    { type: 'boolean', value: true },
    { type: 'options', value: 'Option1' },
    { type: 'text', value: 'Omega' }
  ];

  const handlePrepareCellForEdit = (s, e) => {
    const col = s.columns[e.col];
    const rowData = s.rows[e.row].dataItem;

    // Only intervene for the "value" column
    if (col.binding === 'value') {

      // Dispose existing editor if present
      if (s.activeEditor && s.activeEditor.dispose) {
        s.activeEditor.dispose();
      }

      switch (rowData.type) {

        case 'boolean':
          // Create CheckBox editor
          const chk = new wjcInput.CheckBox(s.hostElement);
          chk.checked = rowData.value;

          chk.checkedChanged.addHandler(() => {
            rowData.value = chk.checked;
          });

          s.activeEditor = chk;
          break;

        case 'options':
          // Create ComboBox editor
          const cbo = new wjcInput.ComboBox(s.hostElement, {
            itemsSource: ['Option1', 'Option2', 'Option3'],
            text: rowData.value
          });

          cbo.textChanged.addHandler(() => {
            rowData.value = cbo.text;
          });

          s.activeEditor = cbo;
          break;

        default:
          // Default text editor
          const input = document.createElement('input');
          input.type = 'text';
          input.value = rowData.value;
          input.style.width = '100%';

          input.addEventListener('change', () => {
            rowData.value = input.value;
          });

          s.activeEditor = {
            hostElement: input,
            dispose: () => {}
          };

          break;
      }
    }
  };

 

With this React setup:

  • A single “Value” column dynamically switches editors per row.
  • Users see checkboxes, combo boxes, or text inputs depending on context.
  • The data model updates immediately when edits occur.
  • The grid layout remains consistent while editing behavior varies intelligently.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Using Different Cell Editors per Row in the Same FlexGrid Column in Vue

A FlexGrid with multiple editors in a row

Background:

Sometimes you want a single column in a FlexGrid to use different editors depending on which row is being edited. For example:

  • One row might require a text editor
  • Another might need a combo box
  • Another might use a checkbox

You can accomplish this in FlexGrid by handling the prepareCellForEdit event and dynamically swapping the default cell editor based on the row’s data.

Steps to Complete:

  1. Handle the prepareCellForEdit event to determine which row is being edited.
  2. Replace the default editor with a custom editor depending on the row’s data.
  3. Ensure the selected editor value is written back to the underlying data item.

Getting Started:

Handle the prepareCellForEdit event to determine which row is being edited

We define sample data where one column (type) determines what kind of editor should be used in the value column.

<template>
  <wj-flex-grid
    ref="flex"
    :itemsSource="data"
    :autoGenerateColumns="false"
    :prepareCellForEdit="onPrepareCellForEdit"
    :cellEditEnded="onCellEditEnded"
  >
    <wj-flex-grid-column
      header="Type"
      binding="type"
      width="120">
    </wj-flex-grid-column>

    <wj-flex-grid-column
      header="Value"
      binding="value"
      width="*">
    </wj-flex-grid-column>

  </wj-flex-grid>
</template>
<script>
import { WjFlexGrid, WjFlexGridColumn } from '@mescius/wijmo.vue2.grid';
import * as wjcInput from '@mescius/wijmo.input';

export default {
  components: {
    WjFlexGrid,
    WjFlexGridColumn
  },

  data() {
    return {
      data: [
        { type: 'text',    value: 'Alpha' },
        { type: 'boolean', value: true },
        { type: 'options', value: 'Option1' },
        { type: 'text',    value: 'Omega' }
      ]
    };
  },

  methods: { ...
  • autoGenerateColumns="false" ensures we define columns manually.
  • prepareCellForEdit allows us to intercept editing.
  • cellEditEnded ensures values persist properly.

 

Replace the default editor with a custom editor depending on the row’s data

When editing begins, we inspect the row’s type and create a different editor accordingly.

    onPrepareCellForEdit(s, e) {
      const col = s.columns[e.col];
      const rowData = s.rows[e.row].dataItem;

      // Only override editor for "value" column
      if (col.binding !== 'value') return;

      // Clean up previous editor if necessary
      if (s.activeEditor?.dispose) {
        s.activeEditor.dispose();
      }

      switch (rowData.type) {

        case 'boolean':
          const chk = new wjcInput.CheckBox(s.hostElement);
          chk.checked = rowData.value;

          chk.checkedChanged.addHandler(() => {
            rowData.value = chk.checked;
          });

          s.activeEditor = chk;
          break;

        case 'options':
          const cbo = new wjcInput.ComboBox(s.hostElement, {
            itemsSource: ['Option1', 'Option2', 'Option3'],
            text: rowData.value
          });

          cbo.textChanged.addHandler(() => {
            rowData.value = cbo.text;
          });

          s.activeEditor = cbo;
          break;

        default:
          const input = document.createElement('input');
          input.type = 'text';
          input.value = rowData.value;
          input.style.width = '100%';

          input.addEventListener('change', () => {
            rowData.value = input.value;
          });

          s.activeEditor = {
            hostElement: input,
            dispose: () => {}
          };
          break;
      }
    },
  • We only modify the "value" column.
  • We inspect rowData.type.

 

Ensure the selected editor value is written back to the underlying data item

Although we update values inside change handlers, we also handle cellEditEnded to ensure the grid’s data model stays synchronized.

    onCellEditEnded(s, e) {
      const item = s.rows[e.row].dataItem;
      const col = s.columns[e.col];

      item[col.binding] = s.getCellData(e.row, e.col);
    }
  }
};
</script>
  • This guarantees the underlying data reflects the final edited value.

 

With this Vue implementation:

  • The Value column dynamically switches editors per row.
  • Boolean rows show checkboxes.
  • Option rows show combo boxes.
  • Text rows use text inputs.
  • Data remains synchronized and consistent.
  • The grid layout stays uniform while editing behavior adapts intelligently.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Using Different Cell Editors Per Row in the Same FlexGrid Column in Angular

FlexGrid showing different cell editors in the same column

Background:

Sometimes you want a single column in a FlexGrid to use different editors depending on which row is being edited. For example, one row might require a text editor, another might need a combo box, and yet another might use a checkbox. You can accomplish this in FlexGrid by handling the prepareCellForEdit event and dynamically swapping the default cell editor for whatever editor suits the current row.

Steps to Complete:

  1. Handle the prepareCellForEdit event to check the row being edited.
  2. Based on the row’s data or index, replace or override the default editor with a custom editor (e.g., ComboBox, Checkbox).
  3. Ensure the selected editor value is written back to the cell on completion.

Getting Started:

Create a FlexGrid with Data

<!-- app.component.html -->
<wj-flex-grid
  #flex
  [itemsSource]="data"
  [autoGenerateColumns]="false"
  (prepareCellForEdit)="onPrepareCellForEdit($event)">
  <wj-flex-grid-column header="Type" binding="type" width="120"></wj-flex-grid-column>
  <wj-flex-grid-column header="Value" binding="value" width="*"></wj-flex-grid-column>
</wj-flex-grid>
// app.component.ts
import { Component, ViewChild } from '@angular/core';
import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcInput from '@mescius/wijmo.input';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html'
})
export class AppComponent {

  @ViewChild('flex', { static: true }) flex: wjcGrid.FlexGrid;

  data = [
    { type: 'text',  value: 'Alpha' },
    { type: 'boolean', value: true },
    { type: 'options', value: 'Option1' },
    { type: 'text',  value: 'Omega' }
  ];
}

 

Handle the prepareCellForEdit event to check the row being edited

In the prepareCellForEdit handler, we inspect the row’s data and replace the default editor with a custom control depending on the value of the type field. For example:

  • If type === 'text', leave the default text editor.
  • If type === 'boolean', use a checkbox.
  • If type === 'options', use a ComboBox with a set of options.
// app.component.ts (continued)
onPrepareCellForEdit(e: wjcGrid.CellRangeEventArgs) {
  const grid = this.flex;
  const col = grid.columns[e.col];
  const rowData = grid.rows[e.row].dataItem;

  // Only intervene for the "value" column
  if (col.binding === 'value') {

    // Remove the default editor (if any)
    if (grid.activeEditor) {
      grid.activeEditor.dispose();
    }

    ...
  • We only override the editor for the value column (col.binding === 'value').
  • We assign the custom control to grid.activeEditor so FlexGrid consistently treats it as the current editor.

 

Based on the row’s data or index, replace or override the default editor with a custom editor (e.g., ComboBox, Checkbox)

...

// Determine which editor to create based on row "type"
    switch (rowData.type) {

      case 'boolean':
        // Create a checkbox
        const chk = new wjcInput.CheckBox(grid.hostElement);
        chk.checked = rowData.value;
        chk.checkedChanged.addHandler(() => {
          rowData.value = chk.checked;
        });
        grid.activeEditor = chk;
        break;

      case 'options':
        // Create a combo box with predefined options
        const cbo = new wjcInput.ComboBox(grid.hostElement, {
          itemsSource: ['Option1', 'Option2', 'Option3'],
          text: rowData.value
        });
        cbo.textChanged.addHandler(() => {
          rowData.value = cbo.text;
        });
        grid.activeEditor = cbo;
        break;

      default:
        // Default text editor
        const input = document.createElement('input');
        input.type = 'text';
        input.value = rowData.value;
        input.style.width = '100%';

        input.addEventListener('change', () => {
          rowData.value = input.value;
        });

        grid.activeEditor = {
          hostElement: input,
          dispose: () => { /* no-op */ }
        };

       ...
  • Based on rowData.type, we dynamically create and assign a different editor.
  • For each control, we wire up change events so modifications update the underlying data item.

 

Ensure the selected editor value is written back to the cell on completion

... 

// Replace the grid’s cell content with our input
        e.panel.setCellData(e.row, e.col, input.value, true);
        e.panel.children[e.row][e.col].appendChild(input);
        break;
    }
  }
}

 

With this Angular setup:

  • A single “Value” column adapts its editor dynamically based on each row’s type.
  • Users see checkboxes, combo boxes, or text inputs as appropriate.
  • The underlying row data updates immediately as edits occur.
  • You maintain a consistent grid layout with context-specific editing experiences per row.

Happy coding!

Andrew Peterson

Technical Engagement Engineer